/* 
 * CSE142, Spring 1999
 * Homework 4
 * Traffic animation

  STARTER PROGRAM

 *
 * Section AA
 */


#include "gp142.h"
#include <stdio.h>
#include <math.h>

#include <time.h>
	/* 
	* <time.h> is included so the current time can be accessed
	* to initialize the random number generator.  If you don't
	* use random numbers (and you don't have to) you can either
	* ignore this #include or delete it.
	*/

/* Logical constants */
#define TRUE    		1
#define FALSE   		0

/* 
 * For many of the GP142 functions, a line width of
 * zero means to fill the shape being drawn.  The
 * constant FILL is used in function calls when a solid
 * shape is desired.
 */
#define FILL 0


/*
 * Symbolic constants.  Change as needed.
 */

/* Menu buttons: */

/* Top-left coordinates of button palette */
#define MENU_TOP		(GP142_YMAX - 5)
#define MENU_LEFT		(-GP142_XMAX + 5)

/* Height and width of buttons in pixels */
#define BUTTON_HEIGHT  	25
#define BUTTON_WIDTH 	75

/* Number of buttons */
#define NUM_BUTTONS 	7


/* Possible locations of mouse clicks: */

/*   Mouse click in some button */
#define BUTTON_CLICK 1

/*   Mouse click elsewhere */
#define OTHER_CLICK 0


/* Coordinates of objects in the drawing */

/* y-coordinate of the top of the ground in the landscape */
#define HORIZON (3 * (GP142_YMAX / 10))

/* Vertical center and width of highway */
#define HIGHWAY_CENTER ((-GP142_YMAX + HORIZON) / 3)
#define HIGHWAY_WIDTH  10


/* Maximum number of vehicles that can appear in the animation */
#define MAX_VEHICLES	5

/* Height and width of a single car */
#define CAR_HEIGHT 24
#define CAR_WIDTH  40

/* Height and width of the opening car */
#define CAR2_HEIGHT 160
#define CAR2_WIDTH	266
/* Position of where the newly added car comes in */
#define GAP		10

/* Number of turns before day change to dusk and then to night */
#define TURN	1

/* Number of vehicles on the second road */
#define VEHICLES	4

/* Speed of the vehicles on the second road */
#define	SPEED	4

/* The total length of the ferry */
#define BOAT_WIDTH	100

/* The cruising speed of the ferry */
#define BOAT_SPEED	2

/*****************************************************************************

     FUNCTION PROTOTYPES

*****************************************************************************/

/* Initialize random number generator.  [Ignore or		*/
/* remove if your program doesn't use random numbers.]	*/
void initialize_random_numbers();

/* Draw the background, not including the sky */
void draw_landscape();

/* Draw the different skies for different time of the day */
void draw_day(int sun_x, int sun_y);
void draw_dusk(int sun_x, int sun_y);
void draw_night(int sun_x, int sun_y);

/* Draw the buttons */
void draw_buttons(int count);

/* Return kind of mouse click (in a button, etc.) */
int  classify_mouse_click(int mouse_x, int mouse_y);

/* Process button click at location x, y.  Update car speed,  */
/* direction, color, and whether traffic is moving as needed. */
void handle_button(int x, int y, int *traffic_moving, 
				   int car_speed[], int car_direction[],
				   int car_color[], int car_x[], int car_y[],
				   int *num_cars);

/* Process the request for addition of a car. Update the database */
/* if it is possible.											  */
void test_car(int num_cars, int car_speed[], int car_direction[],
			  int car_color[], int car_x[], int car_y[]);

/* Update sun coordinates sun_x, sun_y for one tick */
void move_sun(int *sun_x, int *sun_y, int *count);

/* Update all vehicle x, y coordinates, given current x, y */
/* location, direction (+1 or -1), and speed in pixels per tick. */
void move_traffic(int x[], int y[], int direction[], int speed[],
				  int num_cars);

/* Update all vehicle x coordinates on the second road given */
/* current x location. */
void move_traffic2(int x[], int *cars);

/* Draw all vehicles given their current x, y coordinates and color */
void draw_traffic(int x[], int y[], int color[], int num_cars);

/* Draw a single car of the given color with horizontal */
/* center x and bottom y*/
void draw_car(int x, int y, int color);

/* Draw the ferry given its x position */
void draw_boat (int x);

/* Update the ferry position given the number of cars in it and */
/* current position. */
void move_boat (int *boat_x, int *boat_direction, 
				int *traffic2_moving, int *cars);

/* Display error message if internal error is detected. */
void something_is_wrong (void);

/* Draw the traffic light for the ferry */
void draw_light (int cars);

/* Opening of the main program and waits for the user's response */
void opening (void);


/*****************************************************************************

     MAIN

*****************************************************************************/

/*
 * Main program contents:
 *   - Major program variables that persist throughout execution
 *   - Event loop that processes GP142 events until the user quits,
 *     and updates variables and redraws the window as needed.
 */
int main(void)
{
	/* Event handling and buttons: */
	int  quit;				/* = "user has selected quit"				*/
	int  event;				/* the most recent GP142 event				*/
	char key_pressed;		/* last keyboard character from key event	*/
	int  mouse_x, mouse_y;	/* x and y coordinates of latest mouse event*/
	int  click_kind;		/* kind of mouse click (button, etc.)		*/

	/* Information about the sun: */
	int sun_x, sun_y;			/* screen x and y coordinates */

	/* Information about vehicles in the animation:							*/
	int car_x[MAX_VEHICLES];		/* current x-position of the car        */
	int car_y[MAX_VEHICLES];		/* current y-position of the car		*/
	int car_direction[MAX_VEHICLES];/* current direction: +1=right, -1=left */
	int car_color[MAX_VEHICLES];    /* color of the car						*/
	int car_speed[MAX_VEHICLES];	/* speed in pixels per tick when traffic
									   traffic is moving	                */    
	int num_of_cars;				/* the current number of vehicles       */
	int traffic_moving;				/* = "traffic is currently moving"		*/
	int count = 1;					/* the number of turns of the sun		*/
	int car2_color[VEHICLES];		/* color of the car on the second road	*/					
	int car2_x[VEHICLES];			/* x position of the car on the 2nd road*/
	int car2_y[VEHICLES];			/* y position of the car on the 2nd road*/
	int i;							/* variable needed to complete iteration*/
	int num_of_cars2;				/* the current number of cars on road 2	*/
	int traffic2_moving;			/* = "traffic is currently moving"		*/
	int cars = 0;					/* number of cars in the ferry			*/

	/* Information about the boat in the animation: */
	int boat_x;						/* x position of the ferry				*/
	int boat_direction;				/* the direction that the ferry moves	*/
	int text_offset = -GP142_XMAX + 15;	/* horizontal offset of text		*/
	int text_size   = 18;			/* size of text font					*/
	
	
	initialize_random_numbers();
	
	/* Initialize graphics package, clear the window, turn logging off, */
	/* open the opening screen and start animation.*/
	GP142_open();
	GP142_logging(LOG_OFF);
	GP142_clear();
	opening();
	GP142_animate(ANI_RUN);

	/* set initial location of the sun */
	sun_x = GP142_XMAX - 50;
	sun_y = GP142_YMAX - 35;

	/* set initial conditions for the car on the 1st road */
	num_of_cars = 1;
	car_x[0] = 0;
	car_y[0] = HIGHWAY_CENTER;
	car_direction[0] = +1;
	car_speed[0] = 5;
	car_color[0] = RED;
	traffic_moving = TRUE;

	/* set initial conditions for the cars on the 2nd road */
	traffic2_moving = TRUE;
	num_of_cars2 = VEHICLES;
	for (i=0; i < VEHICLES; i++){
		car2_color[i] = (RED + i) % MAX_COLORS;
		car2_x[i] = 0 - i * (CAR_WIDTH + 4 * GAP);
		car2_y[i] = HIGHWAY_CENTER + 8 * HIGHWAY_WIDTH;
		}
		
	/* set initial conditions for the boat */
	boat_x = 20 + BOAT_WIDTH/2;
	boat_direction = +1;

	/* Draw initial landscape, buttons, and traffic */
	draw_day(sun_x,sun_y);
	draw_landscape();
	draw_buttons(count);
	draw_traffic(car2_x, car2_y, car2_color, num_of_cars2);
	draw_traffic(car_x, car_y, car_color, num_of_cars);
	draw_boat(boat_x);
	draw_light(cars);
	/*
	 * Main event loop:
	 * ---- ----- -----
	 * Wait for the next user action, decode it, and call an
	 * appropriate function to handle it.  Repeat until the
	 * user selects quit.
	 */
	quit = FALSE;
	while (!quit) {
		
		/* get next event */
		event = GP142_await_event(&mouse_x, &mouse_y, &key_pressed);
		
		/* perform appropriate action depending on kind of event */
		switch (event) {
		case GP142_QUIT:
			/* Quit selected */
			quit = TRUE;
			break;
			
		case GP142_KBD:
			/* Key pressed.  Not used now.  If the program should		*/
			/* react to keyboard events, insert something appropriate	*/
			/* here.  Note that scanf CANNOT be used with GP142.		*/
			break;
			
		case GP142_MOUSE:
			/* Mouse click.  Determine if in a menu button	*/
			/* or elsewhere and process accordingly.		*/
			click_kind = classify_mouse_click(mouse_x, mouse_y);
			if (click_kind == BUTTON_CLICK) {
				handle_button(mouse_x, mouse_y, &traffic_moving, car_speed,
							  car_direction, car_color, car_x, car_y,
							  &num_of_cars);
			} else {
				/* insert code here (and additional else-if statements) */
				/* to react to mouse clicks elsewhere on the screen */
			}
			if (traffic2_moving)
				move_traffic2(car2_x, &cars);
			if (!traffic2_moving)
				move_boat(&boat_x, &boat_direction, &traffic2_moving,
						  &cars);
			break;
			
		case GP142_PERIODIC:
			/* Timer interval event.  Update everything	*/
			/* that needs to change as time advances.	*/
			move_sun(&sun_x, &sun_y, &count);
			if (traffic_moving)
				move_traffic(car_x, car_y, car_direction, car_speed, 
				             num_of_cars);
			if (traffic2_moving)
				move_traffic2(car2_x, &cars);
			if (!traffic2_moving)
				move_boat(&boat_x, &boat_direction, &traffic2_moving,
						  &cars);
			break;
			
		default:
			/* unknown event */
			break;
			
		}  /*end switch */
		
		/* Check the number of cars in the ferry */
		if (cars == VEHICLES)
			traffic2_moving = FALSE;

		/* Redraw everything */
		if ((count % TURN) == 0) 
			draw_day(sun_x, sun_y);
		if ((count % (2 * TURN)) == 0) 
			draw_dusk(sun_x, sun_y);
		if ((count % (3 * TURN)) == 0)
			draw_night(sun_x, sun_y);
		draw_landscape();
		draw_buttons(count);
		draw_traffic(car2_x, car2_y, car2_color, num_of_cars2);
		draw_traffic(car_x, car_y, car_color, num_of_cars);
		draw_boat(boat_x);
		if (num_of_cars >= MAX_VEHICLES)
			GP142_printfXY (BLACK, text_offset, -GP142_YMAX+50, text_size,
			"YOU HAVE REACHED THE MAXIMUM NUMBER OF CARS!!!");
		draw_light(cars);
				
	}  /* end event loop */
	
	
	/* Termination: shut down graphics window and exit */
	GP142_close();
	return 0;
}  /*end main */


/*****************************************************************************

     BACKGROUND LANDSCAPE

*****************************************************************************/


/* Draw the sky and sun during day time */
void draw_day(int sun_x, int sun_y)
{
	/* Draw the sky */
	GP142_rectangleXY(ICE_BLUE, -GP142_XMAX, -GP142_YMAX,
		GP142_XMAX, GP142_YMAX, FILL);
	
	/* Draw the sun */
	GP142_circleXY(YELLOW, sun_x, sun_y , 20);
}

/* Draw the sky and sun during the afternoon */
void draw_dusk(int sun_x, int sun_y)
{
	/* Draw the sky */
	GP142_rectangleXY(ORANGE, -GP142_XMAX, -GP142_YMAX,
		GP142_XMAX, GP142_YMAX, FILL);
	
	/* Draw the sun */
	GP142_circleXY(RED, sun_x, sun_y , 20);
}

/* Draw the sky and the moon during night time */
void draw_night(int sun_x, int sun_y)
{
	/* Draw the sky */
	GP142_rectangleXY(BLACK, -GP142_XMAX, -GP142_YMAX,
		GP142_XMAX, GP142_YMAX, FILL);
	
	/* Draw the sun */
	GP142_circleXY(WHITE, sun_x, sun_y , 20);
	GP142_circleXY(BLACK, (sun_x + 7), (sun_y + 7) , 20);
}


/* Draw the background, not including the sky */
void draw_landscape()
{
	int text_offset = -GP142_XMAX + 15;	/* horizontal offset of text */
	int text_size   = 12;				/* size of text font */


	/* Draw the ground, highway, lake, and text legend */
	/* Draw the ground */
	GP142_rectangleXY(BROWN, -GP142_XMAX, -GP142_YMAX,
		GP142_XMAX, HORIZON, FILL);
	/* Draw the lake */
	GP142_ovalXY(BLUE, GP142_XMAX / 3, HIGHWAY_CENTER, 
					 GP142_XMAX * 3 / 2,
					 HIGHWAY_CENTER + 7 * HIGHWAY_WIDTH, FILL);
	GP142_ovalXY(BLUE, -50, HIGHWAY_CENTER + 6 * HIGHWAY_WIDTH, 
					 GP142_XMAX * 6 / 5 ,
					 HIGHWAY_CENTER + 15 * HIGHWAY_WIDTH, FILL);
	/* Draw the highways and legend */
	GP142_rectangleXY(WHITE, 
					 -GP142_XMAX, HIGHWAY_CENTER + 7 * HIGHWAY_WIDTH,
					 20 ,HIGHWAY_CENTER + 9 * HIGHWAY_WIDTH, FILL);
	GP142_triangleXY(WHITE,20 ,HIGHWAY_CENTER + 9 * HIGHWAY_WIDTH,
					 20, HIGHWAY_CENTER + 7 * HIGHWAY_WIDTH,
					 55, HIGHWAY_CENTER + 9 * HIGHWAY_WIDTH, FILL);
	GP142_rectangleXY(BLACK, -GP142_XMAX, 
					 HIGHWAY_CENTER + 8 * HIGHWAY_WIDTH,
		             20, HIGHWAY_CENTER + 8 * HIGHWAY_WIDTH, FILL);
	GP142_rectangleXY(WHITE, 
					 -GP142_XMAX, HIGHWAY_CENTER - HIGHWAY_WIDTH,
					 GP142_XMAX, HIGHWAY_CENTER + HIGHWAY_WIDTH,
					 FILL);
	GP142_rectangleXY(BLACK, -GP142_XMAX, HIGHWAY_CENTER,
		             GP142_XMAX, HIGHWAY_CENTER, FILL);
	GP142_printfXY (BLACK, text_offset, -GP142_YMAX+30, text_size,
		"Click a button to control the car.");
	
	
	/*Draw some mountains */
	GP142_triangleXY(MED_GRAY,
		-GP142_XMAX, HORIZON,
		GP142_XMAX, HORIZON,
		0, (4 * GP142_YMAX)/5 ,
		FILL);

	GP142_triangleXY(BLACK,
		-(GP142_XMAX / 5 * 3), HORIZON,
		(GP142_XMAX / 5 * 2), HORIZON,
		0, (4 * GP142_YMAX)/5 ,
		FILL);

	GP142_triangleXY(LT_GRAY,
		(GP142_XMAX /5 * 2), HORIZON,
		GP142_XMAX, HORIZON,
		0, (4 * GP142_YMAX)/5 ,
		FILL);

	GP142_triangleXY(OLIVE,
		-( 5 * GP142_XMAX/4), HORIZON,
		(GP142_XMAX)/3  , HORIZON,
		-(3* GP142_XMAX)/4, (2 * GP142_YMAX)/3 ,
		FILL);

	GP142_triangleXY(CHALK,
		-(GP142_XMAX)/7, HORIZON,
		(GP142_XMAX)/3  , HORIZON,
		-(3* GP142_XMAX)/4, (2 * GP142_YMAX)/3 ,
		FILL);

	GP142_triangleXY(FOREST_GREEN,
		-GP142_XMAX / 3 , HORIZON,
		GP142_XMAX, HORIZON,
		GP142_XMAX, (2 * GP142_YMAX)/3 ,
		FILL);
	
} /*end draw_landscape */



/*****************************************************************************

     BUTTONS AND MOUSE CLICKS

*****************************************************************************/


/* Draws the buttons */
void draw_buttons(int count)
{
	int i;
	int text_offset = MENU_LEFT+10;	/* offset of button text in button */
	int font_size = 12;				/* size of button text */
	int color;						/* color of the button */
	
	if ((count % (3 * TURN)) == 0)
		color = WHITE;
	else 
		color = BLACK;
	/* draw rectangles for each button */
	for(i = 0; i < NUM_BUTTONS; i++) {
		GP142_rectangleXY(color,
			MENU_LEFT,
			MENU_TOP - i * BUTTON_HEIGHT,
			MENU_LEFT + BUTTON_WIDTH,
			MENU_TOP - (i + 1)*BUTTON_HEIGHT, 1);
	}
	
	/* display button text */
	i = MENU_TOP - (BUTTON_HEIGHT/2) - (font_size/2);
	GP142_printfXY(FOREST_GREEN, text_offset, i, font_size, "Go");	
	
	i -= BUTTON_HEIGHT;
	GP142_printfXY(RED, text_offset, i, font_size, "Stop");
	
	i -= BUTTON_HEIGHT;
	GP142_printfXY(color, text_offset, i, font_size, "Faster");
	
	i -= BUTTON_HEIGHT;
	GP142_printfXY(color, text_offset, i, font_size, "Slower");
	
	i -= BUTTON_HEIGHT;
	GP142_printfXY(color, text_offset, i, font_size, "Reverse");
	
	i -= BUTTON_HEIGHT;
	GP142_printfXY(color, text_offset, i, font_size, "New Color");

	i -= BUTTON_HEIGHT;
	GP142_printfXY(color, text_offset, i, font_size, "More Cars");
	
}

/* Classify mouse click at (mouse_x,mouse_y) and return kind */
int  classify_mouse_click(int mouse_x, int mouse_y)
{
	if ((mouse_x > MENU_LEFT) &&
		(mouse_x < MENU_LEFT + BUTTON_WIDTH) &&
		(mouse_y < MENU_TOP) &&
		(mouse_y > (MENU_TOP - NUM_BUTTONS*BUTTON_HEIGHT)))
		return BUTTON_CLICK;
	else
		return OTHER_CLICK;
}



/* Process button click at location x, y.  Update car speed,	*/
/* direction, color, and whether traffic is moving as needed.	*/
void handle_button(int x, int y, int *traffic_moving, int car_speed[],
				   int car_direction[], int car_color[], int car_x[], 
				   int car_y[], int *num_cars)

{
	int buttonNum;		/* number of selected button */
	int i;				/* variable used to complete iteration */

	/* Complain if x coordinate couldn't be inside a button */
	if (x < MENU_LEFT || x > MENU_LEFT + BUTTON_WIDTH) {
		something_is_wrong();
		return;
	}
	
	/* Convert y coordinate to button number from top. */
	buttonNum = (MENU_TOP - y)/BUTTON_HEIGHT;	 
	
	switch(buttonNum) {
	case 0:
		/* go */
		*traffic_moving = TRUE;
		break;
	case 1:
		/* stop */
		*traffic_moving = FALSE;
		break;
		
	case 2:
		/* speed up */
		for (i=0; i<*num_cars; i++){
			car_speed[i] = car_speed[i] + 1;
			}
		break;
	case 3:
		/* slow down */
		for (i=0; i<*num_cars; i++){
			car_speed[i] = car_speed[i] - 1;
			if (car_speed[i] < 0)
				car_speed[i] = 0;
			}
		break;
		
	case 4:
		/* reverse */
		for (i=0; i<*num_cars; i++){
			car_direction[i] = - car_direction[i];
			}
		break;
	case 5:
		/* change car color */
		for (i=0; i<*num_cars; i++){
			car_color[i] = (car_color[i]+1) % MAX_COLORS;
			}
		break;
	case 6:
		/* adding more cars */
		if (*num_cars < MAX_VEHICLES){
			test_car(*num_cars, car_speed, car_direction, car_color,
			         car_x, car_y);
			*num_cars = *num_cars + 1;
			}
		break;
	default:
		/*Bad news if this is ever reached! */
		something_is_wrong();
		break;
	}
}

/*****************************************************************************

	NEW CAR ADDITION

*****************************************************************************/
void test_car(int num_cars, int car_speed[], int car_direction[],
			  int car_color[], int car_x[], int car_y[])
{
	int i = 0;				/* variable used to complete iteration */
	car_x[num_cars] = - GP142_XMAX + CAR_WIDTH/2 + GAP;
	car_y[num_cars] = HIGHWAY_CENTER;
	car_color[num_cars] = RED;
	car_direction[num_cars] = car_direction[num_cars-1];
	car_speed[num_cars] = car_speed[num_cars-1];
	while (i<num_cars){
		if (car_x[num_cars] < car_x[i]){
			if ((car_x[num_cars] + CAR_WIDTH/2)>(car_x[i] - CAR_WIDTH/2)){
				car_x[num_cars] = car_x[i] + CAR_WIDTH + GAP;
				i = 0;
				}
			}
		if (car_x[num_cars] > car_x[i]){
			if ((car_x[num_cars] - CAR_WIDTH/2)<(car_x[i] + CAR_WIDTH/2)){
				car_x[num_cars] = car_x[num_cars] + CAR_WIDTH + GAP;
				i = 0;
				}
			}
		if (car_x[num_cars] == car_x[i]){
			car_x[num_cars] = car_x[i] + CAR_WIDTH + GAP;
			i = 0;	
			}
		if (car_x[num_cars] > (GP142_XMAX - CAR_WIDTH/2))
				i = num_cars;
		i++ ;
		}
	return;					
}
/*****************************************************************************

     TRAFFIC AND OTHER ANIMATED OBJECTS

*****************************************************************************/


/* Update sun coordinates sun_x, sun_y by one tick */
void move_sun(int *sun_x, int *sun_y, int *count) {
	/* Move the sun to the left.  If it reaches the edge, move it */
	/* to the other side and down a bit. */
	(*sun_x) = (*sun_x) - 2;
	if (*sun_x == -GP142_XMAX)
		(*count)++;
	if (*sun_x < -GP142_XMAX -30) {
		*sun_x = - *sun_x;
		*sun_y = *sun_y - 15;
	}
}

/* Update the ferry's position and traffic on the 2nd road given */
/* its current x position its direction, and the number of cars */
/* in it. */
void move_boat(int *boat_x, int *boat_direction, 
			   int *traffic2_moving, int *cars)
{
	int trial_x;		/* new value for x coordinate */
	trial_x = (*boat_x) + BOAT_SPEED * (*boat_direction);
	if (trial_x > GP142_XMAX + BOAT_WIDTH){
		(*boat_direction) = -(*boat_direction);
		return ;
		}
	if (trial_x < (20 + BOAT_WIDTH/2)){
		(*cars) = 0;
		(*traffic2_moving) = TRUE;
		(*boat_x) = 20 + BOAT_WIDTH/2;
		(*boat_direction) = -(*boat_direction);
		return ;
		}
	(*boat_x) = trial_x;
}



/* Update all vehicle x, y coordinates on road 2, given the */
/* current location. */
void move_traffic2(int x[], int *cars)
{
	int trial_x;		/* new value for x coordinate */
	int i;				/* variable used to complete iteration */
	for (i=0; i < VEHICLES; i++){
		trial_x = x[i] + SPEED;
		if (trial_x > 20){
			x[i] = -GP142_XMAX - CAR_WIDTH/2;
			(*cars) ++;
			}
		else
			x[i] = trial_x;
		}
}


/* Update all vehicle x, y coordinates, given current x, y */
/* location, direction (+1 or -1), and speed in pixels per tick, */
void move_traffic(int x[], int y[], int direction[], int speed[], 
				  int num_cars) 
{
	int trial_x;		/* new value for x coordinate */
	int i;				/* variable used to complete iteration */
	/* move vehicle.  If it moves off the edge, reverse direction */
	for (i=0; i<num_cars; i++){
		trial_x = x[i] + (direction[i] * speed[i]);
		if (trial_x > GP142_XMAX + CAR_WIDTH/2)
			x[i] = -GP142_XMAX - CAR_WIDTH/2;
		else
			{
			if (trial_x <-GP142_XMAX - CAR_WIDTH/2)
				x[i] = GP142_XMAX + CAR_WIDTH/2;
			else
				x[i] = trial_x;
			}
		}
}


/* Draw all vehicles given their current x, y coordinates and color */
void draw_traffic(int x[], int y[], int color[], int num_cars)
{
	int i;				/* variable used to complete iteration */
	for (i=0; i<num_cars; i++)
		draw_car(x[i],y[i],color[i]);
}

/* Draw the ferry given the current x position */
void draw_boat(int x)
{
GP142_triangleXY(MED_GRAY, x + BOAT_WIDTH/2 + 35,
						 2 * HIGHWAY_WIDTH + 50, x + BOAT_WIDTH/2 + 35,
						 HIGHWAY_CENTER + 9 * HIGHWAY_WIDTH,
						 x + BOAT_WIDTH/2 + 85,
						 50 + 2 * HIGHWAY_WIDTH, FILL);
GP142_triangleXY(MED_GRAY, x + BOAT_WIDTH/2 + 35,
						 HIGHWAY_CENTER + 9 * HIGHWAY_WIDTH,
						 x + BOAT_WIDTH/2,
						 HIGHWAY_CENTER + 7 * HIGHWAY_WIDTH,
						 x, HIGHWAY_CENTER + 7 * HIGHWAY_WIDTH, FILL);
GP142_rectangleXY(MED_GRAY, x + BOAT_WIDTH/2 + 35,
						 HIGHWAY_CENTER + 9 * HIGHWAY_WIDTH, x,
						 HIGHWAY_CENTER + 9 * HIGHWAY_WIDTH + 15, 
						 FILL);
GP142_triangleXY(LT_GRAY, x - BOAT_WIDTH/2, 50,
						 x - BOAT_WIDTH/2 + 35,
						 50 + 2* HIGHWAY_WIDTH,
						 x - 15, 50, FILL);
GP142_triangleXY(LT_GRAY, x - 15, 80, x + 15, 80,  
						 x + 20, 80 + 2 * HIGHWAY_WIDTH, FILL); 
GP142_triangleXY(LT_GRAY, x + 15, 80, x + 50, 
						 80 + 2 * HIGHWAY_WIDTH,  
						 x + 20, 80 + 2 * HIGHWAY_WIDTH, FILL);
GP142_triangleXY(WHITE, x + 15, 50, x + 50,
						 50 + 2 * HIGHWAY_WIDTH,
						 x + 50, 80 + 2 * HIGHWAY_WIDTH, FILL); 
GP142_triangleXY(WHITE, x + 15, 80, x + 50, 
						 80 + 2 * HIGHWAY_WIDTH,  
						 x + 15, 50, FILL); 
GP142_triangleXY(LT_GRAY, x + 15, 50, x + BOAT_WIDTH/2 + 85, 
						 50 + 2 * HIGHWAY_WIDTH, x + BOAT_WIDTH/2 + 50, 
						 50, FILL);
GP142_triangleXY(LT_GRAY, x + 50, 50 + 2 * HIGHWAY_WIDTH, 
						 x + 85 + BOAT_WIDTH/2, 50 + 2 * HIGHWAY_WIDTH, 
						 x + 15, 50, FILL);
GP142_rectangleXY(MED_GRAY, x - BOAT_WIDTH/2, 
						 HIGHWAY_CENTER + 7 * HIGHWAY_WIDTH,
						 x + BOAT_WIDTH/2, 50, FILL);
GP142_rectangleXY(MED_GRAY, x - 15, 50, x + 15, 80, FILL);
GP142_triangleXY(MED_GRAY, x + BOAT_WIDTH/2, 
						 HIGHWAY_CENTER + 7 * HIGHWAY_WIDTH,
						 x + BOAT_WIDTH/2 + 50, 50,
						 x + BOAT_WIDTH/2, 50, FILL);

						 
						 
}


/* Draw a single car of the given color with horizontal */
/* center x and bottom y*/
void draw_car(int x, int y, int color) {
	GP142_rectangleXY(color, x - CAR_WIDTH*3/10, y + CAR_HEIGHT/2,
						x + CAR_WIDTH*7/10, y + CAR_HEIGHT*19/20, FILL);
	GP142_rectangleXY(color, x - CAR_WIDTH/5, y + CAR_HEIGHT/4,
						x + CAR_WIDTH*7/20, y + CAR_HEIGHT*5/4, FILL);
	GP142_rectangleXY(color, x - CAR_WIDTH/2, y + CAR_HEIGHT/4,
						x + CAR_WIDTH/2, y + CAR_HEIGHT*2/3, FILL);
	GP142_rectangleXY(color, x - CAR_WIDTH*2/5, y + CAR_HEIGHT/4,
						x + CAR_WIDTH*3/20, y + CAR_HEIGHT, FILL);
	GP142_triangleXY(color, x - CAR_WIDTH/2, y + CAR_HEIGHT*2/3,
						x + CAR_WIDTH*2/5, y + CAR_HEIGHT*2/3, 
						x + CAR_WIDTH*2/5, y + CAR_HEIGHT, FILL);
	GP142_triangleXY(color, x - CAR_WIDTH*2/5, y + CAR_HEIGHT,
						x - CAR_WIDTH/5, y + CAR_HEIGHT, 
						x - CAR_WIDTH/5, y + CAR_HEIGHT*5/4, FILL);
	/* Draw the front windshield of the car */
	GP142_triangleXY(ICE_BLUE, x + CAR_WIDTH*3/20, y + CAR_HEIGHT,
						x + CAR_WIDTH/4, y + CAR_HEIGHT*2/3, 
						x + CAR_WIDTH*7/20, y + CAR_HEIGHT*5/4, FILL);
	GP142_triangleXY(ICE_BLUE, x + CAR_WIDTH/4, y + CAR_HEIGHT*2/3,
						x + CAR_WIDTH*9/20, y + CAR_HEIGHT*19/20, 
						x + CAR_WIDTH*7/20, y + CAR_HEIGHT*5/4, FILL);
	/* Draw the front grill of the car */
	GP142_triangleXY(MED_GRAY, x + CAR_WIDTH/2, y + CAR_HEIGHT/4,
						x + CAR_WIDTH/2, y + CAR_HEIGHT*2/3, 
						x + CAR_WIDTH*7/10, y + CAR_HEIGHT*19/20, FILL);
	GP142_triangleXY(MED_GRAY, x + CAR_WIDTH/2, y + CAR_HEIGHT/4,
						x + CAR_WIDTH*7/10, y + CAR_HEIGHT/2, 
						x + CAR_WIDTH*7/10, y + CAR_HEIGHT*19/20, FILL);
	/* Draw the wheels of the car */
	GP142_circleXY(BLACK, x - CAR_WIDTH/4, y + CAR_HEIGHT/4, CAR_HEIGHT/4);
	GP142_circleXY(MED_GRAY, x - CAR_WIDTH/4, y + CAR_HEIGHT/4, CAR_HEIGHT/6);
	GP142_circleXY(BLACK, x + CAR_WIDTH/4, y + CAR_HEIGHT/4, CAR_HEIGHT/4);
	GP142_circleXY(MED_GRAY, x + CAR_WIDTH/4, y + CAR_HEIGHT/4, CAR_HEIGHT/6);
}



/*****************************************************************************

     OTHER

*****************************************************************************/

/* Draw the traffic light given the number of cars in the ferry */
void draw_light(int cars){
	int color1;				/* The red light that lights */
	int color2;				/* The yellow light that lights */
	int color3;				/* The green light that lights */
	GP142_rectangleXY(BLACK, GP142_XMAX - 10, -(GP142_YMAX) + 90,
				GP142_XMAX - 170, -(GP142_YMAX) + 150, FILL);
	if ((cars == 0) || (cars == 1)){
		color1 = GREEN;
		color2 = LT_GRAY;
		color3 = LT_GRAY;}
	if ((cars == 2) || (cars == 3)){
		color1 = LT_GRAY;
		color2 = YELLOW;
		color3 = LT_GRAY;}
	if (cars == 4){
		color1 = LT_GRAY;
		color2 = LT_GRAY;
		color3 = RED;}
	GP142_circleXY(color1, GP142_XMAX - 40, -(GP142_YMAX) + 120, 20);
	GP142_circleXY(color2, GP142_XMAX - 90, -(GP142_YMAX) + 120, 20);
	GP142_circleXY(color3, GP142_XMAX - 140, -(GP142_YMAX) + 120, 20);
}


/* Initialize random number generator */
/* [Ignore or delete if your program  */
/* doesn't user random numbers.] */
void initialize_random_numbers() {
	time_t t;			/* current time */
	srand (time(&t));
}



/* Display error message if internal error is detected. */
void something_is_wrong (void) {
	GP142_printfXY (RED, 0, 0, 16, "BAAAADDD NEWS!");
}


/* Opening of the main program and waits for the user's */
void opening (void){
	int mouse_x;			/* The x-position of the mouse click	*/
	int mouse_y;			/* The y_position of the mouse click	*/
	char key_hit;			/* The key pressed on the keyboard		*/
	/* Draw the sky */
	GP142_rectangleXY(NAVY_BLUE, -(GP142_XMAX), 0, GP142_XMAX, 
						GP142_YMAX, FILL);
	/* Draw the ground */
	GP142_rectangleXY(GREEN, -(GP142_XMAX), CAR2_HEIGHT*14/20,
						GP142_XMAX, -(GP142_YMAX), FILL);
	/* Draw the body of the car */
	GP142_rectangleXY(RED, - CAR2_WIDTH*3/10, CAR2_HEIGHT/2,
						CAR2_WIDTH*7/10, CAR2_HEIGHT*19/20, FILL);
	GP142_rectangleXY(RED, - CAR2_WIDTH/5, CAR2_HEIGHT/4,
						CAR2_WIDTH*7/20, CAR2_HEIGHT*5/4, FILL);
	GP142_rectangleXY(RED, - CAR2_WIDTH/2, CAR2_HEIGHT/4,
						CAR2_WIDTH/2, CAR2_HEIGHT*2/3, FILL);
	GP142_rectangleXY(RED, - CAR2_WIDTH*2/5,CAR2_HEIGHT/4,
						CAR2_WIDTH*3/20, CAR2_HEIGHT, FILL);
	GP142_triangleXY(RED, - CAR2_WIDTH/2, CAR2_HEIGHT*2/3,
						CAR2_WIDTH*2/5, CAR2_HEIGHT*2/3, 
						CAR2_WIDTH*2/5, CAR2_HEIGHT, FILL);
	GP142_triangleXY(RED, - CAR2_WIDTH*2/5, CAR2_HEIGHT,
						- CAR2_WIDTH/5, CAR2_HEIGHT, 
						- CAR2_WIDTH/5, CAR2_HEIGHT*5/4, FILL);
	/* Draw the front windshield of the car */
	GP142_triangleXY(ICE_BLUE, CAR2_WIDTH*3/20, CAR2_HEIGHT,
						CAR2_WIDTH/4, CAR2_HEIGHT*2/3, 
						CAR2_WIDTH*7/20, CAR2_HEIGHT*5/4, FILL);
	GP142_triangleXY(ICE_BLUE, CAR2_WIDTH/4, CAR2_HEIGHT*2/3,
						CAR2_WIDTH*9/20, CAR2_HEIGHT*19/20, 
						CAR2_WIDTH*7/20, CAR2_HEIGHT*5/4, FILL);
	/* Draw the front grill of the car */
	GP142_triangleXY(MED_GRAY, CAR2_WIDTH/2, CAR2_HEIGHT/4,
						CAR2_WIDTH/2, CAR2_HEIGHT*2/3, 
						CAR2_WIDTH*7/10, CAR2_HEIGHT*19/20, FILL);
	GP142_triangleXY(MED_GRAY, CAR2_WIDTH/2, CAR2_HEIGHT/4,
						CAR2_WIDTH*7/10, CAR2_HEIGHT/2, 
						CAR2_WIDTH*7/10, CAR2_HEIGHT*19/20, FILL);
	/* Draw the wheels of the car */
	GP142_circleXY(BLACK, - CAR2_WIDTH/4, CAR2_HEIGHT/4, CAR2_HEIGHT/4);
	GP142_circleXY(MED_GRAY, - CAR2_WIDTH/4, CAR2_HEIGHT/4, CAR2_HEIGHT/6);
	GP142_circleXY(BLACK, CAR2_WIDTH/4, CAR2_HEIGHT/4, CAR2_HEIGHT/4);
	GP142_circleXY(MED_GRAY, CAR2_WIDTH/4, CAR2_HEIGHT/4, CAR2_HEIGHT/6);
	
	/* Print the appropriate text */
	GP142_printfXY(BLACK, -(GP142_XMAX) + 210, -(GP142_YMAX) + 75, 15,
					"Click anywhere on the screen");
	GP142_printfXY(BLACK, -(GP142_XMAX) + 220, -(GP142_YMAX) + 50, 15,
					"or press any key to begin");
	GP142_printfXY(BLACK, -(GP142_XMAX) + 235, -35, 20,
					"SIT BACK, RELAX");
	GP142_printfXY(BLACK, -(GP142_XMAX) + 150, -55, 20,
					"AND ENJOY THE DAY GOES BY");
	GP142_printfXY(BLACK, -(GP142_XMAX) + 10, -(GP142_YMAX) + 10, 10,
					" presented by: Ari Lumbantobing");

	/* Awaits for the user to response */
	GP142_await_event(&mouse_x, &mouse_y, &key_hit);
}
